import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, ViewChild, ElementRef, Input, Output, Pipe, NgModule } from '@angular/core';
import { __classPrivateFieldGet, __classPrivateFieldSet } from 'tslib';
import { ColorGradientUtils, NumberUtils, ColorUtils } from 'soid-ui-util';
import { DomSanitizer } from '@angular/platform-browser';
import { MatIconRegistry, MatIconModule } from '@angular/material/icon';
import interact from 'interactjs';
import { CommonModule } from '@angular/common';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { MatSliderModule } from '@angular/material/slider';
import { TowifyMarkInputModule } from '@towify/components';
import { ColorSketchModule } from 'ngx-color/sketch';
import { MatButtonToggleModule } from '@angular/material/button-toggle';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatTooltipModule } from '@angular/material/tooltip';
import { MatMenuModule } from '@angular/material/menu';
import { MatDividerModule } from '@angular/material/divider';

class TowifyEditorColorPickerService {
    constructor() { }
}
TowifyEditorColorPickerService.ɵprov = i0.ɵɵdefineInjectable({ factory: function TowifyEditorColorPickerService_Factory() { return new TowifyEditorColorPickerService(); }, token: TowifyEditorColorPickerService, providedIn: "root" });
TowifyEditorColorPickerService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
TowifyEditorColorPickerService.ctorParameters = () => [];

/*
 * @author allen
 * @data 2021/3/25 20:09
 */
var _TowifyEditorColorPickerComponent_towifyGradientIcons, _TowifyEditorColorPickerComponent_dragItemWidth, _TowifyEditorColorPickerComponent_gradientData, _TowifyEditorColorPickerComponent_spinRadius;
class TowifyEditorColorPickerComponent {
    constructor(sanitizer, matIconRegistry) {
        this.sanitizer = sanitizer;
        this.matIconRegistry = matIconRegistry;
        this.width = 220;
        _TowifyEditorColorPickerComponent_towifyGradientIcons.set(this, [
            {
                name: 'gradient_color',
                path: 'assets/icons/gradient_color_icon.svg'
            },
            {
                name: 'gradient_image',
                path: 'assets/icons/gradient_image_icon.svg'
            },
            {
                name: 'gradient_linear',
                path: 'assets/icons/gradient_linear_icon.svg'
            },
            {
                name: 'gradient_radial',
                path: 'assets/icons/gradient_radial_icon.svg'
            },
            {
                name: 'gradient_refresh',
                path: 'assets/icons/gradient_refresh_icon.svg'
            },
            {
                name: 'gradient_closest_corner',
                path: 'assets/icons/gradient_closest_corner_icon.svg'
            },
            {
                name: 'gradient_closest_side',
                path: 'assets/icons/gradient_closest_side_icon.svg'
            },
            {
                name: 'gradient_farthest_corner',
                path: 'assets/icons/gradient_farthest_corner_icon.svg'
            },
            {
                name: 'gradient_farthest_side',
                path: 'assets/icons/gradient_farthest_side_icon.svg'
            },
            {
                name: 'gradient_drag_icon',
                path: 'assets/icons/gradient_drag_icon.svg'
            }
        ]);
        this.colorInfo = { color: '#ffffff', opacity: 1 };
        this.onGradientChangeComplete = new EventEmitter();
        this.onGradientChange = new EventEmitter();
        this.onColorChange = new EventEmitter();
        this.onColorChangeComplete = new EventEmitter();
        this.onButtonToggleChanged = new EventEmitter();
        this.backgroundSettings = [
            {
                icon: 'gradient_color',
                name: 'Background Color',
                type: 'color'
            },
            {
                icon: 'gradient_linear',
                name: 'Linear Gradient',
                type: 'linear'
            },
            {
                icon: 'gradient_radial',
                name: 'Radial Gradient',
                type: 'radial'
            },
            {
                icon: 'gradient_image',
                name: 'Overlay',
                type: 'overlay'
            }
        ];
        this.radialInfo = [
            {
                type: 'closest-side',
                icon: 'gradient_closest_side',
                name: 'Closest side',
                description: 'Closest side extends the gradient from the defined position to the closest side.'
            },
            {
                type: 'closest-corner',
                icon: 'gradient_closest_corner',
                name: 'Closest corner',
                description: 'Closest corner extends the gradient from the defined position to the closest corner.'
            },
            {
                type: 'farthest-side',
                icon: 'gradient_farthest_side',
                name: 'Farthest side',
                description: 'Farthest side extends the gradient from the defined position to the farthest side.'
            },
            {
                type: 'farthest-corner',
                icon: 'gradient_farthest_corner',
                name: 'Farthest corner',
                description: 'Farthest corner extends the gradient from the defined position to the farthest corner.'
            }
        ];
        this.gradientAddCursor = 'copy';
        this.selectedColorIndex = 0;
        this.dragItemHeight = 14;
        _TowifyEditorColorPickerComponent_dragItemWidth.set(this, 8);
        _TowifyEditorColorPickerComponent_gradientData.set(this, void 0);
        this.defaultGradient = {
            shared: {
                repeat: false,
                colors: [
                    {
                        hex: '#000000',
                        opacity: 100,
                        percent: 0
                    },
                    {
                        hex: '#ffffff',
                        opacity: 100,
                        percent: 100
                    }
                ]
            },
            linear: {
                angle: 180
            },
            radial: {
                left: 50,
                top: 50,
                sizeType: 'farthest-corner'
            }
        };
        this.dragPointPosition = {
            x: 13,
            y: 23
        };
        this.dragOperatorButtonPosition = {
            x: 22,
            y: 22
        };
        _TowifyEditorColorPickerComponent_spinRadius.set(this, {
            button: 16,
            point: 3
        });
        __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_towifyGradientIcons, "f").forEach(icon => {
            this.matIconRegistry.addSvgIcon(icon.name, this.sanitizer.bypassSecurityTrustResourceUrl(icon.path));
        });
    }
    set gradientInfo(info) {
        __classPrivateFieldSet(this, _TowifyEditorColorPickerComponent_gradientData, info !== null && info !== void 0 ? info : JSON.parse(JSON.stringify(this.defaultGradient)), "f");
        this.resetGradientInfo();
        setTimeout(() => {
            this.prepareCanvas();
            if (!info)
                this.onGradientChanged();
        }, 0);
    }
    get gradientInfo() {
        return __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_gradientData, "f");
    }
    ngOnInit() {
        this.dragButton && this.initSpinButtonDragEvent(this.dragButton.nativeElement);
    }
    onColorChanging(info) {
        this.colorInfo = info;
        this.onColorChange.emit(info);
    }
    onColorChanged(info) {
        this.colorInfo = info;
        this.onColorChangeComplete.emit(info);
    }
    onGradientChanging() {
        this.onGradientChange.emit(this.gradientInfo);
    }
    onGradientChanged() {
        this.onGradientChangeComplete.emit(this.gradientInfo);
    }
    switchBoardByType(type) {
        var _a;
        this.currentType = type;
        this.onButtonToggleChanged.emit(type);
        if (type === 'linear' || type === 'radial') {
            (_a = this.gradientInfo) !== null && _a !== void 0 ? _a : (this.gradientInfo = JSON.parse(JSON.stringify(this.defaultGradient)));
            this.resetGradientInfo();
            this.onGradientChanged();
            setTimeout(() => {
                this.prepareCanvas();
            }, 0);
        }
        else if (this.colorInfo) {
            this.onColorChanging(this.colorInfo);
        }
    }
    prepareCanvas() {
        var _a;
        const rect = (_a = this.gradientCanvas) === null || _a === void 0 ? void 0 : _a.nativeElement.getBoundingClientRect();
        if (!rect)
            return;
        this.drawCanvasGradient();
        this.initGradientItemDragEvent(rect.width - __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_dragItemWidth, "f"));
    }
    resetGradientInfo() {
        var _a, _b;
        var _c, _d;
        if (this.currentType === 'linear') {
            (_a = (_c = this.gradientInfo).linear) !== null && _a !== void 0 ? _a : (_c.linear = { angle: 180 });
            this.dragPointPosition = ColorGradientUtils.getPointByAngleInfo({
                angle: this.gradientInfo.linear.angle,
                radius: __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_spinRadius, "f").button,
                pointRadius: __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_spinRadius, "f").point,
                offset: 3
            });
        }
        if (this.currentType === 'radial') {
            (_b = (_d = this.gradientInfo).radial) !== null && _b !== void 0 ? _b : (_d.radial = {
                left: 50,
                top: 50,
                sizeType: 'farthest-corner'
            });
            this.changeDragOperatorButtonPosition();
        }
    }
    initSpinButtonDragEvent(element) {
        if (interact.isSet(element))
            return;
        let deltaX;
        let deltaY;
        let changeX;
        let changeY;
        let alignPoint;
        let spinButtonPosition;
        const recalculateAngleValue = (event) => {
            var _a;
            if (!((_a = this.gradientInfo) === null || _a === void 0 ? void 0 : _a.linear))
                return;
            deltaX = event.dx;
            deltaY = event.dy;
            changeX = spinButtonPosition.x + deltaX;
            changeY = spinButtonPosition.y + deltaY;
            alignPoint = ColorGradientUtils.getAlignPointByPointInfo({
                point: { x: changeX, y: changeY },
                radius: __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_spinRadius, "f").button,
                pointRadius: __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_spinRadius, "f").point,
                offset: 3
            });
            this.gradientInfo.linear.angle = ColorGradientUtils.getAngleByPointInfo({
                point: alignPoint,
                radius: __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_spinRadius, "f").button,
                pointRadius: __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_spinRadius, "f").point
            });
            this.dragPointPosition = alignPoint;
        };
        interact(element).draggable({
            listeners: {
                start: () => {
                    spinButtonPosition = this.dragPointPosition;
                },
                move: event => {
                    recalculateAngleValue(event);
                    this.onGradientChanging();
                    spinButtonPosition.x = changeX;
                    spinButtonPosition.y = changeY;
                },
                end: event => {
                    recalculateAngleValue(event);
                    this.onGradientChanged();
                    this.dragPointPosition = alignPoint;
                    spinButtonPosition.x = 0;
                    spinButtonPosition.y = 0;
                }
            }
        });
    }
    initPositionOperatorButtonDragEvent(element) {
        if (interact.isSet(element))
            return;
        let changeX;
        let changeY;
        let operatorButtonPosition;
        const positionBoardSize = 44;
        const recalculateShadowValue = (event) => {
            var _a;
            if (!((_a = this.gradientInfo) === null || _a === void 0 ? void 0 : _a.radial))
                return;
            changeX += event.dx;
            changeY += event.dy;
            this.dragOperatorButtonPosition.x = operatorButtonPosition.x + changeX;
            this.dragOperatorButtonPosition.y = operatorButtonPosition.y + changeY;
            this.dragOperatorButtonPosition.x = NumberUtils.convertValueInRange(this.dragOperatorButtonPosition.x, positionBoardSize, 0);
            this.dragOperatorButtonPosition.y = NumberUtils.convertValueInRange(this.dragOperatorButtonPosition.y, positionBoardSize, 0);
            this.gradientInfo.radial.left = parseFloat(((this.dragOperatorButtonPosition.x / positionBoardSize) *
                100).toFixed());
            this.gradientInfo.radial.top = parseFloat(((this.dragOperatorButtonPosition.y / positionBoardSize) *
                100).toFixed());
        };
        interact(element).draggable({
            listeners: {
                start: () => {
                    operatorButtonPosition = Object.assign({}, this.dragOperatorButtonPosition);
                    changeX = 0;
                    changeY = 0;
                },
                move: event => {
                    recalculateShadowValue(event);
                    this.onGradientChanging();
                },
                end: event => {
                    recalculateShadowValue(event);
                    this.onGradientChanged();
                    operatorButtonPosition.x = 0;
                    operatorButtonPosition.y = 0;
                    changeX = 0;
                    changeY = 0;
                }
            }
        });
    }
    onAngleChanged(angle, needToSync = false) {
        var _a;
        if (angle === null)
            return;
        if (!((_a = this.gradientInfo) === null || _a === void 0 ? void 0 : _a.linear))
            return;
        const getCorrectAngle = (angle) => {
            let result = angle;
            if (result > 360)
                result %= 360;
            if (result < 0)
                result = (result % 360) + 360;
            return result;
        };
        this.gradientInfo.linear.angle = getCorrectAngle(angle);
        this.dragPointPosition = ColorGradientUtils.getPointByAngleInfo({
            angle: this.gradientInfo.linear.angle,
            radius: __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_spinRadius, "f").button,
            pointRadius: __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_spinRadius, "f").point,
            offset: 3
        });
        if (needToSync) {
            this.onGradientChanged();
        }
        else {
            this.onGradientChanging();
        }
    }
    onRadialLeftPositionChanged(left) {
        var _a;
        if (!((_a = this.gradientInfo) === null || _a === void 0 ? void 0 : _a.radial))
            return;
        this.gradientInfo.radial.left = NumberUtils.convertValueInRange(left);
        this.changeDragOperatorButtonPosition();
        this.onGradientChanged();
    }
    onRadialTopPositionChanged(top) {
        var _a;
        if (!((_a = this.gradientInfo) === null || _a === void 0 ? void 0 : _a.radial))
            return;
        this.gradientInfo.radial.top = NumberUtils.convertValueInRange(top);
        this.changeDragOperatorButtonPosition();
        this.onGradientChanged();
    }
    addColorGradient(event) {
        var _a, _b;
        if (!this.gradientInfo)
            return;
        const canvasContext = (_a = this.gradientCanvas) === null || _a === void 0 ? void 0 : _a.nativeElement.getContext('2d');
        const canvasRect = (_b = this.gradientCanvas) === null || _b === void 0 ? void 0 : _b.nativeElement.getBoundingClientRect();
        if (canvasContext && canvasRect) {
            const clickPoint = {
                x: event.clientX - canvasRect.x,
                y: event.clientY - canvasRect.y
            };
            const clickColorData = canvasContext.getImageData(clickPoint.x, clickPoint.y, 1, 1).data;
            const percent = NumberUtils.convertValueInRange(Math.round((clickPoint.x / (canvasRect.width - __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_dragItemWidth, "f"))) * 100));
            this.gradientInfo.shared.colors.push({
                percent,
                hex: ColorUtils.rgbToHex(clickColorData[0], clickColorData[1], clickColorData[2]),
                opacity: parseFloat(((clickColorData[3] / 255) * 100).toFixed(0))
            });
            this.selectedColorIndex = this.gradientInfo.shared.colors.length - 1;
            this.sortColor();
            this.drawCanvasGradient(canvasContext);
        }
        this.onGradientChanged();
    }
    reverseColorGradient() {
        if (!this.gradientInfo)
            return;
        const colorLength = this.gradientInfo.shared.colors.length;
        let index = 0;
        let tempPercent = 0;
        for (index; index < colorLength / 2; index += 1) {
            tempPercent = this.gradientInfo.shared.colors[index].percent;
            this.gradientInfo.shared.colors[index].percent = this.gradientInfo.shared.colors[colorLength - 1 - index].percent;
            this.gradientInfo.shared.colors[colorLength - 1 - index].percent = tempPercent;
        }
        this.sortColor();
        this.drawCanvasGradient();
        this.onGradientChanged();
    }
    onSelectedColorChange(color, needToSync = false) {
        var _a;
        if ((_a = this.gradientInfo) === null || _a === void 0 ? void 0 : _a.shared.colors[this.selectedColorIndex]) {
            this.gradientInfo.shared.colors[this.selectedColorIndex].hex =
                color.hex === 'transparent' ? '#000000' : color.hex;
            this.gradientInfo.shared.colors[this.selectedColorIndex].opacity =
                color.rgb.a * 100;
            this.drawCanvasGradient();
            if (needToSync) {
                this.onGradientChanged();
            }
            else {
                this.onGradientChanging();
            }
        }
    }
    onSelectedPercentChange(percent, isListening = false) {
        var _a;
        if (percent === null)
            return;
        if ((_a = this.gradientInfo) === null || _a === void 0 ? void 0 : _a.shared.colors[this.selectedColorIndex]) {
            this.gradientInfo.shared.colors[this.selectedColorIndex].percent = NumberUtils.convertValueInRange(percent);
            this.sortColor();
            this.drawCanvasGradient();
            if (isListening) {
                this.onGradientChanging();
            }
            else {
                this.onGradientChanged();
            }
        }
    }
    initGradientItemDragEvent(maxWidth) {
        if (maxWidth <= 0)
            return;
        let changeX = 0;
        let startPercent = 0;
        interact('.gradient-drag-item')
            .draggable({
            cursorChecker: () => 'ew-resize',
            listeners: {
                start: () => {
                    var _a, _b;
                    startPercent = (_b = (_a = this.gradientInfo) === null || _a === void 0 ? void 0 : _a.shared.colors[this.selectedColorIndex]) === null || _b === void 0 ? void 0 : _b.percent;
                    changeX = 0;
                    this.gradientAddCursor = 'ew-resize';
                },
                move: event => {
                    changeX += event.dx;
                    this.onSelectedPercentChange(startPercent + Math.round((changeX / maxWidth) * 100), true);
                },
                end: event => {
                    changeX += event.dx;
                    this.onSelectedPercentChange(startPercent + Math.round((changeX / maxWidth) * 100));
                    changeX = 0;
                    startPercent = 0;
                    this.gradientAddCursor = 'copy';
                }
            }
        })
            .styleCursor(false);
    }
    changeDragOperatorButtonPosition() {
        var _a;
        if (!((_a = this.gradientInfo) === null || _a === void 0 ? void 0 : _a.radial))
            return;
        this.dragOperatorButtonPosition.x =
            (this.gradientInfo.radial.left / 100) * 44;
        this.dragOperatorButtonPosition.y =
            (this.gradientInfo.radial.top / 100) * 44;
    }
    sortColor() {
        if (!this.gradientInfo)
            return;
        const selectedColor = this.gradientInfo.shared.colors[this.selectedColorIndex];
        let findSelected = false;
        this.gradientInfo.shared.colors
            .sort((a, b) => (a.percent < b.percent ? -1 : 1))
            .forEach((colorInfo, index) => {
            if (colorInfo === selectedColor) {
                findSelected = true;
                this.selectedColorIndex = index;
            }
        });
        if (!findSelected) {
            this.selectedColorIndex = 0;
        }
    }
    drawCanvasGradient(canvasContext) {
        var _a, _b;
        const context = canvasContext !== null && canvasContext !== void 0 ? canvasContext : (_a = this.gradientCanvas) === null || _a === void 0 ? void 0 : _a.nativeElement.getContext('2d');
        if (!context)
            return;
        context.clearRect(0, 0, this.width, this.dragItemHeight);
        const gradient = context.createLinearGradient(0, 0, this.width - __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_dragItemWidth, "f"), this.dragItemHeight);
        (_b = this.gradientInfo) === null || _b === void 0 ? void 0 : _b.shared.colors.forEach(colorInfo => {
            gradient.addColorStop(colorInfo.percent / 100, ColorUtils.hexToRgba(colorInfo.hex, colorInfo.opacity));
        });
        context.fillStyle = gradient;
        context.fillRect(0, 0, this.width - __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_dragItemWidth, "f"), this.dragItemHeight);
        if (this.gradientInfo && this.gradientInfo.shared.colors.length > 0) {
            const lastColorInfo = this.gradientInfo.shared.colors[this.gradientInfo.shared.colors.length - 1];
            context.fillStyle = ColorUtils.hexToRgba(lastColorInfo.hex, lastColorInfo.opacity);
            context.fillRect(this.width - __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_dragItemWidth, "f"), 0, __classPrivateFieldGet(this, _TowifyEditorColorPickerComponent_dragItemWidth, "f"), this.dragItemHeight);
        }
    }
}
_TowifyEditorColorPickerComponent_towifyGradientIcons = new WeakMap(), _TowifyEditorColorPickerComponent_dragItemWidth = new WeakMap(), _TowifyEditorColorPickerComponent_gradientData = new WeakMap(), _TowifyEditorColorPickerComponent_spinRadius = new WeakMap();
TowifyEditorColorPickerComponent.decorators = [
    { type: Component, args: [{
                selector: 'towify-editor-color-picker',
                template: "<div class=\"gradient-container\" [style.width.px]=\"width\">\n  <mat-button-toggle-group\n    class=\"background-settings-grid\"\n    [value]=\"currentType\"\n  >\n    <mat-button-toggle\n      *ngFor=\"let item of backgroundSettings\"\n      [value]=\"item.type\"\n      aria-label=\"{{ item.name }}\"\n      matTooltip=\"{{ item.name }}\"\n      (click)=\"switchBoardByType(item.type)\"\n    >\n      <mat-icon [svgIcon]=\"item.icon\"></mat-icon>\n    </mat-button-toggle>\n  </mat-button-toggle-group>\n  <mat-divider></mat-divider>\n  <ng-container [ngSwitch]=\"currentType\">\n    <div class=\"angle-item\" *ngSwitchCase=\"'linear'\">\n      <div class=\"horizontal-item\">\n        <div class=\"spin-button\">\n          <div\n            class=\"spin-mark\"\n            #dragPoint\n            [style.top.px]=\"dragPointPosition.y\"\n            [style.left.px]=\"dragPointPosition.x\"\n          ></div>\n        </div>\n        <mat-slider\n          color=\"primary\"\n          [value]=\"gradientInfo?.linear?.angle\"\n          (input)=\"onAngleChanged($event.value)\"\n          (valueChange)=\"onAngleChanged($event, true)\"\n          [max]=\"360\"\n        ></mat-slider>\n        <towify-mark-input\n          type=\"number\"\n          [max]=\"361\"\n          [min]=\"-1\"\n          [fixContent]=\"'Degree'\"\n          [value]=\"gradientInfo?.linear?.angle\"\n          (onChanged)=\"onAngleChanged($event, true)\"\n        ></towify-mark-input>\n      </div>\n    </div>\n    <div class=\"radial-item\" *ngSwitchCase=\"'radial'\">\n      <div class=\"radial-position-item\">\n        <span> Position </span>\n        <div\n          class=\"radial-position-operator\"\n          [style.background-image]=\"\n            'url(assets/icons/radio_position_board_pattern_icon.svg)'\n          \"\n        >\n          <div\n            class=\"position-operator-button\"\n            #dragButton\n            [style.top.px]=\"dragOperatorButtonPosition.y\"\n            [style.left.px]=\"dragOperatorButtonPosition.x\"\n          >\n            <mat-icon [svgIcon]=\"'gradient_drag_icon'\"></mat-icon>\n            {{ initPositionOperatorButtonDragEvent(dragButton) }}\n          </div>\n        </div>\n        <div class=\"radial-position-container\">\n          <span> Left </span>\n          <towify-mark-input\n            [max]=\"100\"\n            [min]=\"0\"\n            type=\"number\"\n            [fixContent]=\"'%'\"\n            [width]=\"60\"\n            [value]=\"gradientInfo?.radial?.left\"\n            (onChanged)=\"onRadialLeftPositionChanged($event)\"\n          ></towify-mark-input>\n          <span> Top </span>\n          <towify-mark-input\n            [max]=\"100\"\n            [min]=\"0\"\n            type=\"number\"\n            [fixContent]=\"'%'\"\n            [width]=\"60\"\n            [value]=\"gradientInfo?.radial?.top\"\n            (onChanged)=\"onRadialTopPositionChanged($event)\"\n          ></towify-mark-input>\n        </div>\n      </div>\n      <div class=\"type-container\">\n        <span>Size</span>\n        <mat-button-toggle-group\n          class=\"radial-size-toggle-group\"\n          [value]=\"gradientInfo?.radial?.sizeType\"\n        >\n          <mat-button-toggle\n            *ngFor=\"let item of radialInfo\"\n            [value]=\"item.type\"\n            [matTooltip]=\"item.description\"\n            (click)=\" gradientInfo!.radial!.sizeType = item.type; onGradientChanged()\n            \"\n          >\n            <mat-icon [svgIcon]=\"item.icon\"></mat-icon>\n          </mat-button-toggle>\n        </mat-button-toggle-group>\n      </div>\n    </div>\n  </ng-container>\n  <!-- Common Color Selection -->\n  <ng-container *ngIf=\"currentType === 'color'; else gradientSettings\">\n    <div class=\"horizontal-item\">\n      <div\n        class=\"color-preview\"\n        [style.background-image]=\"'url(assets/icons/transparency_icon.svg)'\"\n      >\n        <div\n          class=\"color\"\n          [matMenuTriggerFor]=\"colorPicker\"\n          [style.background-color]=\"colorInfo.color\"\n          [style.opacity]=\"colorInfo.opacity / 100\"\n        ></div>\n      </div>\n      <mat-slider\n        [color]=\"'primary'\"\n        thumbLabel\n        [max]=\"100\"\n        [min]=\"0\"\n        [value]=\"colorInfo.opacity\"\n        (input)=\"colorInfo.opacity = $event.value === null ? 1 : $event.value; onColorChanging(colorInfo)\"\n        (valueChange)=\"onColorChanged(colorInfo)\"\n      ></mat-slider>\n      <towify-mark-input\n        [width]=\"80\"\n        [max]=\"100\"\n        [min]=\"0\"\n        type=\"number\"\n        [value]=\"colorInfo.opacity\"\n        [fixContent]=\"'Opacity'\"\n        (onChanged)=\"colorInfo.opacity = $event; onColorChanged(colorInfo)\"\n      ></towify-mark-input>\n    </div>\n  </ng-container>\n  <ng-template #gradientSettings>\n    <div class=\"setting-item\">\n      <div\n        class=\"gradient-preview\"\n        [style.background-image]=\"'url(assets/icons/transparency_icon.svg)'\"\n        (mousedown)=\"addColorGradient($event)\"\n        [style.cursor]=\"gradientAddCursor\"\n      >\n        <canvas\n          [width]=\"width\"\n          [height]=\"this.dragItemHeight\"\n          class=\"gradient-canvas\"\n          #gradientCanvas\n        ></canvas>\n        <div class=\"gradient-drag-operator\">\n          <div\n            *ngFor=\"let colorInfo of gradientInfo!.shared.colors; let i = index\"\n            [className]=\"\n              i === selectedColorIndex\n                ? 'gradient-drag-item selected'\n                : 'gradient-drag-item normal'\n            \"\n            [style.background-color]=\"\n              (i === selectedColorIndex ? colorInfo.hex : '')\n                | hexToRgba: colorInfo.opacity\n            \"\n            [style.left]=\"colorInfo.percent + '%'\"\n            (mousedown)=\"selectedColorIndex = i; $event.stopPropagation()\"\n          ></div>\n        </div>\n      </div>\n      <div class=\"repeat-item\">\n        <div>\n          <mat-checkbox\n            color=\"primary\"\n            [checked]=\"gradientInfo!.shared.repeat\"\n            (change)=\"\n              gradientInfo!.shared.repeat = $event.checked; onGradientChanged()\n            \"\n          >\n            <span>Repeat</span>\n          </mat-checkbox>\n        </div>\n        <div\n          class=\"reverse-item\"\n          [title]=\"'Reverse'\"\n          (click)=\"reverseColorGradient()\"\n        >\n          <mat-icon [svgIcon]=\"'gradient_refresh'\"></mat-icon>\n        </div>\n      </div>\n      <div class=\"horizontal-item\">\n        <div\n          class=\"color-preview\"\n          [style.background-image]=\"'url(assets/icons/transparency_icon.svg)'\"\n        >\n          <div\n            class=\"color\"\n            [matMenuTriggerFor]=\"gradientColorPicker\"\n            [style.backgroundColor]=\"\n              gradientInfo!.shared.colors[selectedColorIndex]?.hex\n            \"\n            [style.opacity]=\"\n              gradientInfo!.shared.colors[selectedColorIndex]!.opacity / 100\n            \"\n          ></div>\n        </div>\n        <mat-slider\n          color=\"primary\"\n          thumbLabel\n          [max]=\"100\"\n          [value]=\"gradientInfo!.shared.colors[selectedColorIndex]?.percent\"\n          (input)=\"onSelectedPercentChange($event.value, true)\"\n          (valueChange)=\"onSelectedPercentChange($event)\"\n        ></mat-slider>\n        <towify-mark-input\n          [width]=\"80\"\n          [max]=\"100\"\n          [min]=\"0\"\n          type=\"number\"\n          [value]=\"gradientInfo!.shared.colors[selectedColorIndex]?.percent\"\n          [fixContent]=\"'Range'\"\n          (onChanged)=\"onSelectedPercentChange($event)\"\n        ></towify-mark-input>\n      </div>\n    </div>\n  </ng-template>\n</div>\n\n<mat-menu #gradientColorPicker class=\"color-picker\">\n  <color-sketch\n    *ngIf=\"!!gradientInfo\"\n    (click)=\"$event.stopPropagation()\"\n    [disableAlpha]=\"true\"\n    [color]=\"\n      gradientInfo!.shared.colors[selectedColorIndex]!.hex\n        | hexToRgba: gradientInfo!.shared.colors[selectedColorIndex]!.opacity\n    \"\n    (onChange)=\"onSelectedColorChange($event.color)\"\n    (onChangeComplete)=\"onSelectedColorChange($event.color, true)\"\n  ></color-sketch>\n</mat-menu>\n\n<mat-menu #colorPicker class=\"color-picker\">\n  <color-sketch\n    *ngIf=\"!!colorInfo\"\n    (click)=\"$event.stopPropagation()\"\n    [color]=\"colorInfo.color | hexToRgba: colorInfo.opacity\"\n    (onChange)=\"\n      onColorChanging({\n        color: $event.color.hex,\n        opacity: $event.color.rgb.a * 100\n      })\n    \"\n    (onChangeComplete)=\"\n      onColorChanged({\n        color: $event.color.hex,\n        opacity: $event.color.rgb.a * 100\n      })\n    \"\n  ></color-sketch>\n</mat-menu>\n\n",
                styles: ["*{box-sizing:border-box}a,button,h1,input,label,li,textarea,ul{border:none;outline:none}div{outline:none;-moz-user-select:none;-webkit-user-select:none;-ms-user-select:none;user-select:none;-o-user-select:none}input::-webkit-inner-spin-button,input::-webkit-outer-spin-button{-webkit-appearance:none;margin:0}img{-o-object-fit:cover;object-fit:cover}::-webkit-scrollbar{display:none}.menu-title{font-size:12px;margin:8px 15px;color:rgba(0,0,0,.25);font-weight:700}.mat-form-field{width:100%;font-size:10px}.mat-form-field ::ng-deep .mat-form-field-wrapper{margin:unset}.mat-menu-content .mat-menu-item{line-height:35px;height:35px;font-size:11px;font-family:-apple-system,BlinkMacSystemFont,SF UI Text,Helvetica Neue,PingFang SC,Hiragino Sans GB,Microsoft YaHei UI,Microsoft YaHei,Arial,sans-serif}.mat-expansion-panel-content{display:grid}.cdk-overlay-container .mat-menu-panel{min-width:unset;min-height:unset}:host span{font-family:-apple-system,BlinkMacSystemFont,SF UI Text,Helvetica Neue,PingFang SC,Hiragino Sans GB,Microsoft YaHei UI,Microsoft YaHei,Arial,sans-serif;font-size:10px;color:#ccc}:host .gradient-container{width:100%;display:grid;grid-template-rows:24px auto auto;grid-row-gap:10px}:host .gradient-container .background-settings-grid{display:grid;grid-template-columns:repeat(4,1fr)}:host .gradient-container .mat-button-toggle-group-appearance-standard :first-child{border-left:none}:host .gradient-container .mat-button-toggle-appearance-standard{background-color:#0c0c0c}:host .gradient-container .mat-button-toggle-disabled.mat-button-toggle-appearance-standard{background-color:#222}:host .gradient-container .mat-button-toggle-checked{background-color:#303030}:host ::ng-deep .mat-button-toggle-button{height:100%;display:grid}:host ::ng-deep .mat-button-toggle-label-content{line-height:14px;align-self:center;margin-top:-2px}:host ::ng-deep .mat-button-toggle-label-content .mat-icon{width:14px;height:14px}:host .setting-item{display:grid;align-items:center}:host .spin-button{width:32px;height:32px;background-color:#363636;box-shadow:0 0 3px rgba(0,0,0,.5);border-radius:18px;position:relative}:host .spin-button .spin-mark{touch-action:none;top:13px;left:23px;position:absolute;width:6px;height:6px;background-color:#fff;border-radius:3px}:host .repeat-item{display:grid;grid-template-columns:auto 32px;-moz-column-gap:5px;column-gap:5px;align-items:center;border-top:1px solid #363636;border-bottom:1px solid #363636;margin:5px 0;padding:5px 0}:host .repeat-item ::ng-deep .mat-checkbox-inner-container{width:14px;height:14px}:host .horizontal-item{display:grid;grid-template-columns:40px auto 80px;-moz-column-gap:5px;column-gap:5px;align-items:center}:host .horizontal-item .mat-slider{padding:0}:host .horizontal-item .mat-slider-horizontal{min-width:auto;height:auto}:host .horizontal-item .mat-slider-horizontal ::ng-deep .mat-slider-wrapper{top:0}:host .horizontal-item .mat-form-field{width:75px;font-size:9px;margin-left:5px}:host .horizontal-item .mat-form-field ::ng-deep .mat-form-field-wrapper{padding-bottom:0}:host .angle-item{display:grid;grid-row-gap:10px}:host .radial-item{display:grid;grid-row-gap:6px}:host .radial-item .radial-position-item{display:grid;grid-template-columns:40px 72px auto;-moz-column-gap:4px;column-gap:4px;align-items:center}:host .radial-item .radial-position-item .radial-position-operator{background-color:#2b2b2b;width:68px;height:68px;overflow:hidden;border:1px solid #212121;border-radius:5px;position:relative}:host .radial-item .radial-position-item .radial-position-operator .position-operator-button{position:absolute;display:grid;align-items:center;justify-content:center;width:22px;height:22px}:host .radial-item .radial-position-item .radial-position-operator .position-operator-button .mat-icon{width:18px;height:18px;font-size:18px;line-height:18px}:host .radial-item .radial-position-item .radial-position-container{display:grid;grid-template-columns:1fr auto;align-items:center;gap:4px 4px;justify-items:center}:host .reverse-item{display:grid;justify-content:end;cursor:pointer}:host .reverse-item .mat-icon{width:16px;height:16px}:host .radial-size-toggle-group{width:100%;height:24px;display:grid;grid-template-columns:repeat(4,1fr)}:host .mat-button-toggle-checked{background-color:#2b2b2b}:host ::ng-deep .mat-button-toggle{display:grid;align-items:center}:host .color-preview{border:2px solid hsla(0,0%,100%,.25);border-radius:30px;width:30px;height:30px;justify-self:start;box-shadow:0 2px 5px rgba(0,0,0,.15);overflow:hidden;background-size:30px 30px}:host .color-preview .color{width:100%;height:100%;background-color:#000}:host .gradient-preview{height:16px;overflow:visible;grid-column:1/-1;box-sizing:border-box;border:1px solid rgba(0,0,0,.8);border-radius:2px;position:relative;margin:10px 0}:host .gradient-canvas{position:absolute}:host .gradient-drag-operator{position:absolute;width:calc(100% - 7px);height:100%}:host .gradient-drag-item{touch-action:none;pointer-events:auto;position:absolute;height:calc(100% - 2px);top:1px;width:8px;border-radius:1px;background-color:#ebebeb;opacity:1;cursor:ew-resize}:host .normal{box-shadow:0 0 0 1px rgba(0,0,0,.3)}:host .selected{box-shadow:0 0 0 2px #ebebeb,0 0 0 3px rgba(0,0,0,.3),inset 0 0 0 1px rgba(0,0,0,.3)}:host .color-picker.mat-menu-panel{max-width:200px}:host .color-picker .mat-menu-content:not(:empty){padding-top:0;padding-bottom:0}:host .drag-ghost{width:1px;height:1px;left:1px;top:1px;opacity:0;z-index:-1}"]
            },] }
];
TowifyEditorColorPickerComponent.ctorParameters = () => [
    { type: DomSanitizer },
    { type: MatIconRegistry }
];
TowifyEditorColorPickerComponent.propDecorators = {
    dragButton: [{ type: ViewChild, args: ['dragButton', { read: ElementRef, static: true },] }],
    currentType: [{ type: Input }],
    width: [{ type: Input }],
    gradientInfo: [{ type: Input }],
    colorInfo: [{ type: Input }],
    onGradientChangeComplete: [{ type: Output }],
    onGradientChange: [{ type: Output }],
    onColorChange: [{ type: Output }],
    onColorChangeComplete: [{ type: Output }],
    onButtonToggleChanged: [{ type: Output }],
    gradientCanvas: [{ type: ViewChild, args: ['gradientCanvas', { read: ElementRef },] }]
};

/*
 * @author kaysaith
 * @date 2021/5/16
 */
class HexToRgbaPipe {
    transform(hex, opacity) {
        if (hex === '') {
            return '';
        }
        return ColorUtils.hexToRgba(hex, opacity);
    }
}
HexToRgbaPipe.decorators = [
    { type: Pipe, args: [{
                name: 'hexToRgba'
            },] }
];

class TowifyEditorColorPickerModule {
}
TowifyEditorColorPickerModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    TowifyEditorColorPickerComponent, HexToRgbaPipe
                ],
                imports: [
                    CommonModule,
                    BrowserAnimationsModule,
                    MatSliderModule,
                    MatIconModule,
                    TowifyMarkInputModule,
                    ColorSketchModule,
                    MatButtonToggleModule,
                    MatCheckboxModule,
                    MatTooltipModule,
                    MatMenuModule,
                    MatDividerModule
                ],
                exports: [
                    TowifyEditorColorPickerComponent
                ]
            },] }
];

/*
 * Public API Surface of towify-editor-color-picker
 */

/**
 * Generated bundle index. Do not edit.
 */

export { TowifyEditorColorPickerComponent, TowifyEditorColorPickerModule, TowifyEditorColorPickerService, HexToRgbaPipe as ɵa };
//# sourceMappingURL=towify-editor-color-picker.js.map
